// GIT-Labor
// main.h

////////////////////////////////////////////////////////////////////////////////
// Header-Dateien
#include <iostream>		// Header fr die Standard-IO-Objekte (z.B. cout, cin)
#include <stdlib.h>

using namespace std;


#include "CWayPoint.h"


//         by Value       by Pointer       by Reference
//         Kopie(n byte)  Adresse(4 byte)  Aliasname (->Adresse, 4 byte)
void fkt3( CWayPoint wp,  CWayPoint *pWp,  CWayPoint &rWp )
{
   cout << "in fkt3:  wp: "; wp.print();
   cout << "in fkt3: pWp: "; pWp->print();   // <=> (*pWp).print()
   cout << "in fkt3: rWp: "; rWp.print();
}

CWayPoint fkt()
{
   CWayPoint wp( "fkt", 0., 0. );
   return wp;  // by Value (returns copy)
}

CWayPoint fktFALSCH()
{
   CWayPoint *pWp = new CWayPoint( "fktFALSCH", 0., 0. );
   return *pWp;  // no way to delete pWp after return to main => memory leak
}

CWayPoint *pFktFALSCH()
{
   CWayPoint wp( "pFktFALSCH", 0., 0. );
   return &wp;  // compile-warning: address of local variable 'wp' returned
}

CWayPoint *pFkt()
{
   CWayPoint *pWp = new CWayPoint( "pFkt", 0., 0. );
   return pWp;  // by pointer (returns address)
}

CWayPoint &rFktFALSCH()
{
   CWayPoint wp( "rFktFALSCH", 0., 0. );
   return wp;  // compile-warning: reference to local variable 'wp' returned
}

CWayPoint &rFkt()
{
   CWayPoint *pWp = new CWayPoint( "rFkt", 0., 0. );
   return *pWp;  // by reference (returns reference)
}

// Hauptprogramm
// Dient als Testrahmen, von hier aus werden die Klassen aufgerufen
int main (void)
{
   CWayPoint wp1( "Eins", 1., 1. );
   CWayPoint wp2( "Zwei", 1., 2. );
   CWayPoint wp3( "Drei", 1., 3. );
   cout << "in main before fkt3( wp1, &wp2, wp3 );" << endl;
   fkt3( wp1, &wp2, wp3 );
   cout << "in main after return from fkt3" << endl;
   cout << endl;

   CWayPoint *pWp1 = new CWayPoint( "pEins", 2., 1. );
   CWayPoint *pWp2 = new CWayPoint( "pZwei", 2., 2. );
   CWayPoint *pWp3 = new CWayPoint( "pDrei", 2., 3. );
   cout << "in main before fkt3( *pWp1, pWp2, *pWp3 );" << endl;
   fkt3( *pWp1, pWp2, *pWp3 );
   cout << "in main after return from fkt3" << endl;
   delete pWp1;
   delete pWp2;
   delete pWp3;
   cout << endl;

   CWayPoint wp4 = fkt();
   cout << "in main wp4 from fkt: "; wp4.print();
   cout << endl;

   CWayPoint wp5 = fktFALSCH();  // => Memory Leak (CWaypoint object left after return from main)
   cout << "in main: wp5 from fktFALSCH: "; wp5.print();
   cout << endl;

   CWayPoint *pWp = pFktFALSCH();  // => Dangling Reference
// cout << "in main: pWp from pFktFALSCH: "; pWp->print();  // => runtime-error
   cout << "in main: pWp from pFktFALSCH:   " << pWp << " <= dangling reference (no more valid after auto delete on return)" << endl;
   cout << endl;

   pWp = pFkt();
   cout << "in main pWp from fkt: "; pWp->print();
   delete pWp;  // delete object created in pFkt
   cout << endl;

   pWp = &rFktFALSCH();  // => Dangling Reference
// cout << "in main: pWp from rFktFALSCH: "; pWp->print();  // => runtime-error
   cout << "in main: pWp from rFktFALSCH:   " << pWp << " <= dangling reference (no more valid after auto delete on return)" << endl;
   cout << endl;

   pWp = &rFkt();  // store adress of returned reference in pointer variable
   cout << "in main: pWP from rFkt: "; pWp->print();
   delete pWp;  // uses pointer to delete object created in rFkt
   cout << endl;

   cout << "\"before\" return from main" << endl;
   return 0;
}
